(define-module (ordo task)
  #:use-module (ordo logger)
  #:use-module (srfi srfi-9)
  #:export (task
            task?
            task-name
            task-pre-condition
            task-action
            run-task))

(define-record-type <task>
  (make-task name action pre-condition)
  task?
  (name task-name)
  (pre-condition task-pre-condition)
  (action task-action))

(define* (task #:key name action (pre-condition (const #t)))
  (make-task name action pre-condition))

(define (run-task t conn)
  (if ((task-pre-condition t) conn)
      (begin
        (log-msg 'NOTICE "Running task " (task-name t))
        ((task-action t) conn))
      (log-msg 'NOTICE "Skipping task " (task-name t) ": pre-condition not met")))
